;*************************************
eeprom_init:
		ldi		temp0,(1<<EERIE)
		out		EECR,temp0
		sei
		ret

eeprom_rdy:
		;siehe eeprom_write ;** man kann in der wartezeit andere sachen erledigen
		;bis der int kommt, um dann weitere daten an den eeprom zum schreiben zu senden 
		;nur bei eeprom schreiben mglich
		reti

;Adreessierung im eeprom
adr_cnt:lds		temp0,eep_adrl
		inc		temp0
		cpi		temp0,$ff
		breq	adr_cnt2
		sts		eep_adrl,temp0
		ret
adr_cnt2:
		clr		temp0
		sts		eep_adrl,temp0
		lds		temp0,eep_adrh
		inc		temp0
		sts		eep_adrh,temp0
		cpi		temp0,$02
		breq	error_eeprom
		ret
error_eeprom:
		;voll
		ret

EEPROM_write:				
		sbic 	EECR,EEWE		;** falls eewe im eecr noch gesetzt
		rjmp 	EEPROM_write	;** spring zu zurck
		lds		r18,eep_adrh
		out 	EEARH, r18		;highbyte der adr
		lds		r17,eep_adrl
		out 	EEARL, r17		;lowbyte der adr
		out 	EEDR,r16		;zu speichernder wert
		sbi 	EECR,EEMWE		;sperrt eeprom master write enable
		sbi 	EECR,EEWE		;setze EEWE um eeprom zu schreiben
		ret

EEPROM_read:				
		sbic 	EECR,EEWE		;falls eewe im eecr noch gesetzt
		rjmp 	EEPROM_read		;springe zurck
		lds		r18,eep_adrh
		out 	EEARH, r18		;highbyte der adr
		lds		r17,eep_adrl
		out 	EEARL, r17		;lowbyte der adr
		sbi 	EECR,EERE		;sperrt lesen des eeproms
		in 		r16,EEDR		;zu lesender wert
		ret
