;************************uart_init mit RX interrupt**********************
usart_init_int:
		ldi			temp0,$19	;9600 Baud einstellen PDF S.133 table52
		out 		UBRRL,temp0
		ldi 		temp0,$8e	;URSEL=1 UCSRC1 or UBRRH0,USBS=1 stoppbits2,
		out 		UCSRC,temp0	;UCSZ1,0 =1 8bit TX u RX, UMSEL=0 asynchron
								;paritt keine
		ldi 		temp0,$98	;enable RX u TX  <=8bit(UCSZ2=0) 
		out 		UCSRB,temp0	;
		ldi			temp0,$01
		out			UCSRA,temp0
		ret

usart_reinit:
		ldi 		temp0,$98	;enable RX u TX  <=8bit(UCSZ2=0) 
		out 		UCSRB,temp0	;
		ret
		
;************************uart_deinit********************************
usart_all_aus:
		clr			temp0
		out			UCSRB,temp0
		out			UCSRC,temp0
		out			UBRRL,temp0
		out			UBRRH,temp0
		ret

usart_ofln:									;wenn unterprogramme nicht 
		clr			temp0					;gestrt werden drfen
		out			UCSRB,temp0				;nur usart ofline
		ret

;*********************pointer laden fr tranceived mode**************
pointer_load:
		ldi			yl,low($0078)
		ldi			yh,high($0078)
		ret

;**********************Header vorbereiten zum senden*****************
header:	lds			temp1,rxdata1			;id des empfnger (ist ja schon vorhanden)
		st			y+,temp1				;speichern
		ldi			temp1,idnr				;id des senders
		st			y+,temp1				;speichern
		clr			temp1
		st			y+,temp1				;Platzhalter fr die Anzahl der zu bertragenden bytes=nbyts
		ret

;**********************senden von Daten 1durchlauf = NByte***********
;$20=Anfang ;$aa=ready ;byte1=RxID ; Byte2=TxID ; Nbyts=wieviele byts ; Byte4-8=daten ; $AA=Ende
;$20,$AA werden nicht Abgespeichert
tx_rout:subi		yl,$78				;yl wird weiter gezhlt also YL-$78=Nbytes
		sts			$007a,yl			;fr sender zu bertragung
		sts			nbyts,yl			;

		ldi			temp1,$20			;sende $20 fr datenbertragung starten
		rcall		data_transmit		;daten senden
		rcall		tx_rout_wait		;Wartet auf Antwort $aa

		ldi			yl,low($0078)		;pointer festlegen
		ldi			yh,high($0078)		;
		lds			temp0,nbyts			;
		add			temp0,yl
tx_rout_2:
		ld			temp1,y+			;lade daten von y in temp1
		rcall		data_transmit		;daten senden
		cp			yl,temp0
		brne		tx_rout_2
		ldi			temp1,$aa			;sende $aa fr datenbertragung ende
		rcall		data_transmit		;daten senden
		ret

;*******wartet auf antwort, das dass senden starten kann************
tx_rout_wait:
		lds			temp0,rxcmd
		cpi			temp0,$aa
		brne		tx_rout_wait
		clr			temp0
		sts			rxcmd,temp0
		ret

;**********************daten_senden*********************************
data_transmit:
		sbis		UCSRA,UDRE
		rjmp		data_transmit
		out 		UDR,temp1			; Put LSB data (r17) into buffer, tranceived data
		ret

;**********************Empfang von Daten 1durchlauf = NByte***********
;$20=Anfang ;$aa=ready ;byte1=RxID ; Byte2=TxID ; Nbyts=wieviele byts ; Byte4-8=daten ; $AA=Ende
;$20,$AA werden nicht Abgespeichert
rx_rout:lds			temp0,rxcmd			;wenn $20 gesendet wird
		cpi			temp0,$20			;dann spring in die RxRoutine
		breq		rx_rout2
		ret								;wenn nichts dann ende
rx_rout2:
		clt								;tflag lschen
		rcall		quittung			;sende eine besttigung mit $aa
		ldi			yl,low($0070)		;ab welcher adresse gespeichert werden soll
		ldi			yh,high($0070)		;SRAM-Adr 70
rx_rout3:
		lds			temp1,rxcmd
		cpi			temp1,$aa
		breq		rx_rout4
		brtc		rx_rout3			;tflag ? 
		st			y+,temp1			;jetzt werden die daten erst gespeichert
		clt
		rjmp		rx_rout3					;tflg lschen
rx_rout4:	
		lds			temp0,rxdata0		;vergleich der Id
		cpi			temp0,idnr
		breq		rx_end
		clr			temp0				;id falsch lsche rxdata0
		sts			rxdata0,temp0
rx_end:	clr			temp0
		sts			rxcmd,temp0
		ret

;*********************daten_empfangen (ber Interrupt)*****************
rx_complete:
		in 			temp1,UDR			; Put LSB data (r17) into buffer, received Data
		sts			rxcmd,temp1
		set
		reti

;**********************daten_empfangen (polling)**********************
data_received:
		sbis		UCSRA,RXC
		rjmp		data_received
		in 			temp1,UDR			; Put data from buffer into r17, received Data
		ret

;************************Wandlung fr pc Zahl*************************
ascii_form:
		lds			temp1,$0061
		push		temp1
		swap		temp1
		andi		temp1,$0f
		ori			temp1,$30
		st			y+,temp1
		pop			temp1
		andi		temp1,$0f
		ori			temp1,$30
		st			y+,temp1
		lds			temp1,$0062
		push		temp1
		swap		temp1
		andi		temp1,$0f
		ori			temp1,$30
		st			y+,temp1
		pop			temp1
		andi		temp1,$0f
		ori			temp1,$30
		st			y+,temp1
		ret

;**************************Quittierung********************************
quittung:
		ldi			temp1,$aa
		rcall		data_transmit		;bereit fr datenempfang=quittierung
		ret

/*
;************************uart_init ohne RX interrupt*********************
usart_init:
		ldi			temp0,$19	;9600 Baud einstellen PDF S.133 table52
		out 		UBRRL,temp0
		ldi 		temp0,$8e	;URSEL=1 UCSRC1 or UBRRH0,USBS=1 stoppbits2,
		out 		UCSRC,temp0	;UCSZ1,0 =1 8bit TX u RX, UMSEL=0 asynchron
								;paritt keine
		ldi 		temp0,$08	;enable RX u TX  <=8bit(UCSZ2=0) 
		out 		UCSRB,temp0	;
		ldi			temp0,$01
		out			UCSRA,temp0
		ret
*/



